"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _terraI18n = require("terra-i18n");
require("./baseStyles");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }
function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }
function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
var propTypes = {
  /**
   * The component(s) that will be wrapped by `<Base />`.
   */
  children: _propTypes.default.node.isRequired,
  /**
   * The locale name.
   */
  locale: _propTypes.default.string.isRequired,
  /**
   * Customized translations provided by consuming application only for current locale.
   */
  /* eslint-disable consistent-return */
  customMessages: function customMessages(props, propName, componentName) {
    if (Object.keys(props[propName]).length !== 0 && props.locale === undefined) {
      return new Error("Missing locale prop for ".concat(propName, " in ").concat(componentName, " props"));
    }
  },
  /**
   * Activates [React Strict Mode](https://reactjs.org/docs/strict-mode.html) for descendants
   */
  strictMode: _propTypes.default.bool,
  /**
   * Whether or not the error should be logged and thrown if something goes wrong. When false, the error will only be logged to the
   * console an error.
   */
  throwOnI18nLoadError: _propTypes.default.bool,
  /**
   * The component(s) that will be wrapped by `<Base />` ONLY in the event that translations have not been loaded yet.
   * NOTE: Absolutely no locale-dependent logic should be utilized in this placeholder.
   */
  translationsLoadingPlaceholder: _propTypes.default.node
};
var defaultProps = {
  customMessages: {},
  strictMode: false,
  throwOnI18nLoadError: false
};
var Base = /*#__PURE__*/function (_React$Component) {
  _inherits(Base, _React$Component);
  function Base(props) {
    var _this;
    _classCallCheck(this, Base);
    _this = _callSuper(this, Base, [props]);
    _this.state = {
      areTranslationsLoaded: false,
      locale: props.locale,
      messages: {}
    };
    return _this;
  }
  _createClass(Base, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.locale !== undefined) {
        try {
          (0, _terraI18n.i18nLoader)(this.props.locale, this.setState, this);
        } catch (e) {
          // eslint-disable-next-line no-console
          console.error(e);
          if (this.props.throwOnI18nLoadError) {
            throw e;
          }
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.locale !== undefined && this.props.locale !== prevProps.locale) {
        try {
          (0, _terraI18n.i18nLoader)(this.props.locale, this.setState, this);
        } catch (e) {
          // eslint-disable-next-line no-console
          console.error(e);
          if (this.props.throwOnI18nLoadError) {
            throw e;
          }
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
        children = _this$props.children,
        customMessages = _this$props.customMessages,
        strictMode = _this$props.strictMode,
        translationsLoadingPlaceholder = _this$props.translationsLoadingPlaceholder;
      var messages = _objectSpread(_objectSpread({}, this.state.messages), customMessages);
      var renderChildren = strictMode ? /*#__PURE__*/_react.default.createElement(_react.default.StrictMode, null, children) : children;
      if (!this.state.areTranslationsLoaded) return /*#__PURE__*/_react.default.createElement("div", null, translationsLoadingPlaceholder);
      return /*#__PURE__*/_react.default.createElement(_terraI18n.I18nProvider, {
        locale: this.state.locale,
        messages: messages
      }, renderChildren);
    }
  }]);
  return Base;
}(_react.default.Component);
Base.propTypes = propTypes;
Base.defaultProps = defaultProps;
var _default = exports.default = Base;